/*
Copyright 2020 The Knative Authors

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
	v1alpha1 "knative.dev/eventing-contrib/gitlab/pkg/apis/bindings/v1alpha1"
)

// FakeGitLabBindings implements GitLabBindingInterface
type FakeGitLabBindings struct {
	Fake *FakeBindingsV1alpha1
	ns   string
}

var gitlabbindingsResource = schema.GroupVersionResource{Group: "bindings.knative.dev", Version: "v1alpha1", Resource: "gitlabbindings"}

var gitlabbindingsKind = schema.GroupVersionKind{Group: "bindings.knative.dev", Version: "v1alpha1", Kind: "GitLabBinding"}

// Get takes name of the gitLabBinding, and returns the corresponding gitLabBinding object, and an error if there is any.
func (c *FakeGitLabBindings) Get(name string, options v1.GetOptions) (result *v1alpha1.GitLabBinding, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(gitlabbindingsResource, c.ns, name), &v1alpha1.GitLabBinding{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.GitLabBinding), err
}

// List takes label and field selectors, and returns the list of GitLabBindings that match those selectors.
func (c *FakeGitLabBindings) List(opts v1.ListOptions) (result *v1alpha1.GitLabBindingList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(gitlabbindingsResource, gitlabbindingsKind, c.ns, opts), &v1alpha1.GitLabBindingList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.GitLabBindingList{ListMeta: obj.(*v1alpha1.GitLabBindingList).ListMeta}
	for _, item := range obj.(*v1alpha1.GitLabBindingList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested gitLabBindings.
func (c *FakeGitLabBindings) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(gitlabbindingsResource, c.ns, opts))

}

// Create takes the representation of a gitLabBinding and creates it.  Returns the server's representation of the gitLabBinding, and an error, if there is any.
func (c *FakeGitLabBindings) Create(gitLabBinding *v1alpha1.GitLabBinding) (result *v1alpha1.GitLabBinding, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(gitlabbindingsResource, c.ns, gitLabBinding), &v1alpha1.GitLabBinding{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.GitLabBinding), err
}

// Update takes the representation of a gitLabBinding and updates it. Returns the server's representation of the gitLabBinding, and an error, if there is any.
func (c *FakeGitLabBindings) Update(gitLabBinding *v1alpha1.GitLabBinding) (result *v1alpha1.GitLabBinding, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(gitlabbindingsResource, c.ns, gitLabBinding), &v1alpha1.GitLabBinding{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.GitLabBinding), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeGitLabBindings) UpdateStatus(gitLabBinding *v1alpha1.GitLabBinding) (*v1alpha1.GitLabBinding, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(gitlabbindingsResource, "status", c.ns, gitLabBinding), &v1alpha1.GitLabBinding{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.GitLabBinding), err
}

// Delete takes name of the gitLabBinding and deletes it. Returns an error if one occurs.
func (c *FakeGitLabBindings) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(gitlabbindingsResource, c.ns, name), &v1alpha1.GitLabBinding{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeGitLabBindings) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(gitlabbindingsResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &v1alpha1.GitLabBindingList{})
	return err
}

// Patch applies the patch and returns the patched gitLabBinding.
func (c *FakeGitLabBindings) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.GitLabBinding, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(gitlabbindingsResource, c.ns, name, pt, data, subresources...), &v1alpha1.GitLabBinding{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.GitLabBinding), err
}
