/*
Copyright 2020 The Knative Authors

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
	v1alpha1 "knative.dev/eventing-contrib/kafka/channel/pkg/apis/messaging/v1alpha1"
)

// FakeKafkaChannels implements KafkaChannelInterface
type FakeKafkaChannels struct {
	Fake *FakeMessagingV1alpha1
	ns   string
}

var kafkachannelsResource = schema.GroupVersionResource{Group: "messaging.knative.dev", Version: "v1alpha1", Resource: "kafkachannels"}

var kafkachannelsKind = schema.GroupVersionKind{Group: "messaging.knative.dev", Version: "v1alpha1", Kind: "KafkaChannel"}

// Get takes name of the kafkaChannel, and returns the corresponding kafkaChannel object, and an error if there is any.
func (c *FakeKafkaChannels) Get(name string, options v1.GetOptions) (result *v1alpha1.KafkaChannel, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(kafkachannelsResource, c.ns, name), &v1alpha1.KafkaChannel{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.KafkaChannel), err
}

// List takes label and field selectors, and returns the list of KafkaChannels that match those selectors.
func (c *FakeKafkaChannels) List(opts v1.ListOptions) (result *v1alpha1.KafkaChannelList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(kafkachannelsResource, kafkachannelsKind, c.ns, opts), &v1alpha1.KafkaChannelList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.KafkaChannelList{ListMeta: obj.(*v1alpha1.KafkaChannelList).ListMeta}
	for _, item := range obj.(*v1alpha1.KafkaChannelList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested kafkaChannels.
func (c *FakeKafkaChannels) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(kafkachannelsResource, c.ns, opts))

}

// Create takes the representation of a kafkaChannel and creates it.  Returns the server's representation of the kafkaChannel, and an error, if there is any.
func (c *FakeKafkaChannels) Create(kafkaChannel *v1alpha1.KafkaChannel) (result *v1alpha1.KafkaChannel, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(kafkachannelsResource, c.ns, kafkaChannel), &v1alpha1.KafkaChannel{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.KafkaChannel), err
}

// Update takes the representation of a kafkaChannel and updates it. Returns the server's representation of the kafkaChannel, and an error, if there is any.
func (c *FakeKafkaChannels) Update(kafkaChannel *v1alpha1.KafkaChannel) (result *v1alpha1.KafkaChannel, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(kafkachannelsResource, c.ns, kafkaChannel), &v1alpha1.KafkaChannel{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.KafkaChannel), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeKafkaChannels) UpdateStatus(kafkaChannel *v1alpha1.KafkaChannel) (*v1alpha1.KafkaChannel, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(kafkachannelsResource, "status", c.ns, kafkaChannel), &v1alpha1.KafkaChannel{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.KafkaChannel), err
}

// Delete takes name of the kafkaChannel and deletes it. Returns an error if one occurs.
func (c *FakeKafkaChannels) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(kafkachannelsResource, c.ns, name), &v1alpha1.KafkaChannel{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeKafkaChannels) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(kafkachannelsResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &v1alpha1.KafkaChannelList{})
	return err
}

// Patch applies the patch and returns the patched kafkaChannel.
func (c *FakeKafkaChannels) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.KafkaChannel, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(kafkachannelsResource, c.ns, name, pt, data, subresources...), &v1alpha1.KafkaChannel{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.KafkaChannel), err
}
